﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;

namespace SSPA_Remote
{
    public partial class Form_setup : Form
    {
        public Form_setup()
        {
            InitializeComponent();
        }

        private void Form_setup_Load(object sender, EventArgs e)
        {
            this.comboBox_PA.Text = Form1.paComPort;
            this.textBox_HRD_ip.Text = Form1.hrdIP;
            this.checkBox_HRDenable.Checked = Form1.hrdEnable;
           
        }
       //Cancel button
        private void bnt_Cancel_Click(object sender, EventArgs e)
        {
            this.Close();                                   //close form
         }

        //Save Button
        private void btn_Save_Click(object sender, EventArgs e)
        {
            IniFile ini = new IniFile(Form1.iniPath);
            string selected = this.comboBox_PA.GetItemText(this.comboBox_PA.SelectedItem);     //get Com port from combobox
            if (selected == "") selected = Form1.paComPort;                                    //if nothing has been selected, use previous port
            ini.IniWriteValue("SSPA_Remote", "ComPort", selected);                             //save com port to ini file
            ini.IniWriteValue("SSPA_Remote", "HrdIP", this.textBox_HRD_ip.Text);               //save HRD IP address to ini file      
            
            if (checkBox_HRDenable.Checked) ini.IniWriteValue("SSPA_Remote", "HrdEnable", "1");//save Enable status to ini file
            else ini.IniWriteValue("SSPA_Remote", "HrdEnable", "0");
           
            Form1.paComPort = selected;                     //update with selected port
            Form1.hrdIP = textBox_HRD_ip.Text;              //update witch selected timeout
            Form1.hrdEnable = checkBox_HRDenable.Checked;   
            this.Close();                                    //close form

        }

        private void comboBox_PA_MouseClick(object sender, MouseEventArgs e)
        {
            string[] ArrayComPortsNames = null;
            int index = -1;
            string ComPortName = null;

            ArrayComPortsNames = SerialPort.GetPortNames();
            do
            {
                index += 1;
                comboBox_PA.Items.Add(ArrayComPortsNames[index]);
            }

            while (!((ArrayComPortsNames[index] == ComPortName)
                          || (index == ArrayComPortsNames.GetUpperBound(0))));
            Array.Sort(ArrayComPortsNames);

            //want to get first out
            if (index == ArrayComPortsNames.GetUpperBound(0))
            {
                ComPortName = ArrayComPortsNames[0];
            }
            comboBox_PA.Text = ArrayComPortsNames[0];
        }
    }
}
